(*
 * func.pas
 * 	Pascal Program to generate data file for GRAF3D.
 *)
program func (input,output);

CONST
	PI = 3.14159;

(* Global Variables *)
var
	outfile: text;
	filename: string[64];
	i,j: integer;
	l,t,x,y,z: real;
	xinc, yinc: real;
	xbeg, xend, ybeg, yend: real;
	Xsize, Ysize: integer;	(* size in the X and Y direction *)
	okay: char;
	Zscale: real;


(* The user-specified function *)
function func( x,y:real ):real;
var
	z, x2, y2: real;
begin
	x2 := x*x;
	y2 := y*y;
	z := (x2 + 2*x2) * exp(1-x2-y2);
	func := z * Zscale;
end;

procedure getsizes;
begin
	Writeln('Please enter the grid size: ');
	Xsize := 0;
	while ( Xsize < 1 ) do begin
		Write('   In X direction: ');
		Readln(Xsize)
		end;
	Ysize := 0;
	while ( Ysize < 1 ) do begin
		Write('   In Y direction: ');
		Readln(Ysize)
		end;
	Writeln('Please enter the starting & ending points.');
	Write('    Starting X value: ');
	Readln(xbeg);
	Write('      Ending X value: ');
	Readln(xend);
	Write ('    Starting Y value: ');
	Readln(ybeg);
	Write ('      Ending Y value: ');
	Readln(yend);

	Writeln('Please enter a value to scale the function result by:');
	Writeln('(A scale < 1 decreases the magnitude, scale > 1 increase it)');
	Write ('   Scale: ');
	Readln(Zscale);

	xinc := (xend - xbeg) / Xsize;
	yinc := (yend - ybeg) / Ysize;

	Writeln;
	Writeln('X-axis: From ',xbeg:7:3,' to ',xend:7:3,' by ',xinc:7:3,' increments.');
	Writeln('Y-axis: From ',ybeg:7:3,' to ',yend:7:3,' by ',yinc:7:3,' increments.');
	Writeln('Function scale is ',Zscale:7:3);
end;

(*****************************)
(* beginning of main program *)
(*****************************)
begin
	okay := 'N';
	while ( (okay <> 'Y') and (okay <> 'y') ) do begin
		Textmode;
		getsizes;
		Writeln;
		Write ('Are these parameters okay? (y/n) ');
		Readln(okay);
		Writeln;
		end;
	Write('Please enter filename to produce - ');
	Read(filename);
	Assign(outfile,filename);
	Rewrite(outfile);
	Writeln;
	Writeln('Creating file, please wait ...');

	(* write point lines *)
	x := xbeg;
	for i := 0 to Xsize do begin
		y := ybeg;
		for j := 0 to Ysize do begin
			z := func(x,y);
			writeln(outfile,'p ',i*(ysize+1)+j,' ',x:8:5,' ',y:8:5,
				' ',z:8:5);
			y := y + yinc;
			end;
		x := x + xinc;
		end;
			
	(* write polygon lines *)
	for  i := 0 to (Xsize-1) do
		for j := 0 to (Ysize-1) do
			writeln(outfile,'y ',i*(ysize+1)+j,' ',
				(i+1)*(ysize+1)+j,' ',(i+1)*(ysize+1)+(j+1),' ',
					i*(ysize+1)+(j+1) );
	close(outfile);
	writeln('All finished. Bye!');
end.

(* end of func.pas *)
